#!/usr/bin/python

# Programmer: Andrew Robert
# Function: Generic method to get message from a queue.
#           This script is intended to be run from the command line 
#
#       Usage:
#
#        mq_getmsg.py  {host}{port}{queue manager}{queue} {# of messages} 
#
#       Example:
#      
#
#        mq_getmsg.py  BONGO 1414 SNOOPY ALT.TEST.Q  20
#
#
# Version History:
# v1.0 - 04/15/05 - AAR - Initial revision 
#                      
#
#


import pymqi, CMQC, sys, os, string

#
# Test number of arguments passed
#
def test_num_arguments():
    if len(sys.argv) == 1:
        print '\n\t\tInsufficient arguments\n\n\n'
        print '\tStandard Usage:\n'
        print '\tmq_getmsg.py {host}{port}{queue manager} {queue} {# of messages to get }\n'
        print '\n\tExample:\n'
        print '\tmq_getmsg.py MQIDEV1 1415 ADMIN.TEST.Q 20 \n\n'
        sys.exit(1)


  
#
# Determine number of command line parameters passed to program
# and validate key options using called functions
#
test_num_arguments()
arg_array_size =len(sys.argv)



#
# Automatically adjust passed values to upper case to reflect queue manager
# naming conventions
#
host   = sys.argv[1]
quemgr = sys.argv[3]
queue  = sys.argv[4]
sys.argv[1] = host.upper()
sys.argv[3] = quemgr.upper()
sys.argv[4] = queue.upper()

#
# Form and set the environmental variable for the connection
#  
command="ADMIN.SVRCONN/TCP/"+sys.argv[1]+"("+sys.argv[2]+")"
os.environ['MQSERVER'] =command 

#
# Form and execute put to queue manager on specified queue
#
qmgr = pymqi.QueueManager()
getQ = pymqi.Queue(qmgr, sys.argv[4])
counter=0

    
while counter < sys.argv[5]:
    try:
        arg = getQ.get()
        print arg
        counter = counter +1
    except:
        print '\nNo messages\n'
        sys.exit(0) 


